#
# fragtest - generate file system fragmentation for testing
#
# By drmn4ea - released under the WFTPL (http://www.wtfpl.net/)
#

import random
import os

##################################

# Dir in which to start generating files
path = "J:/frags/"
# Percentage of file fragments to leave behind. Larger # = less freespace between fragments.
# Range is 0.0 (empty) ... 1.0 (full)
filldensity = 0.5
# fragment size in bytes
minfragsize = 1000000
maxfragsize = 32000000

##################################


# First completely fill the disk with files (sizes randomly chosen from range minfragsize ~ maxfragsize).

filling = True
temp_fname = 0

print "Writing files..."

while filling:
    try:
        with open(path + hex(temp_fname), 'wb') as f:
            f.write("A" * random.randrange(minfragsize, maxfragsize))
        temp_fname = temp_fname + 1
    except IOError:
        print "IOError (disk filled?), now deleting some files..."
        filling = False

# Then delete some percentage of those files at random. This will leave small holes scattered all over the disk.

print "Removing files..."

while temp_fname:
    if random.random() > filldensity:
        os.remove(path + hex(temp_fname))
    temp_fname = temp_fname - 1

print "Done!"
